> For the complete documentation index, see [llms.txt](https://docs.lukkit.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lukkit.net/storage/the-storageobject.md).

# The StorageObject

This is the object returned when calling [plugin.getStorageObject(file: string)](https://github.com/artex-development/docs.lukkit.net/tree/872d59d6ba1d99b239c03950ebfcb8df546f66aa/storage/Globals/README.md#plugingetstorageobjectfile-string). Here it is represented as `storage`.

## `storage:getType()`: `"yaml"` or `"json"`

Returns the type of the storage object, it will be either `"yaml"` or `"json"`.

## `storage:exists(path: string)`: boolean

Returns true if the path exists in the storage file and false if not

## `storage:setDefaultValue()`: boolean

Sets the default value for a path. Returns true if the value is set and false if not

## `storage:setValue(path: string, value: any)`: boolean

Sets the value of the path in the storage file. Returns false if there was an error setting the value.

## `storage:getValue(path: string)`: any

Gets the value from the storage file from its path.

## `storage:clearValue(path: string)`: boolean

Deletes the value from the storage file from its path. Returns false if there was an error setting the value.

## `storage:save()`

Save the current storage object to its file. It is recommended to do this on plugin disable.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.lukkit.net/storage/the-storageobject.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
